﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread.Model;

namespace addRows
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            /* 
            * 
            * PROBLEM: Loading a xml with 2000 rows, I cannot add a row when I specify an index greater than 500 (default row count), 
            * even though the xml has 2000 rows.
            * 
            * Default row count when adding a fpSpread component in a form = 500
            * Row count in the xml saved with the Spread Designer = 2000
                 
            * The error happens in v6.0.3501.2008, in v5.0.3518 is OK.
            * 
            * If I don´t load the xml, it IS possible to add rows at the end.
            */

            string currentDir = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
            
            string xmlPathWorkbook = System.IO.Path.Combine(currentDir, "test_workbook.xml");
            string xmlPathSheetview = System.IO.Path.Combine(currentDir, "test_sheetview.xml");

            try
            {
                // Loading xml as sheetview - ERROR  when adding a row at the end
                fpSpread1.Sheets[0].Open(xmlPathSheetview);

                // Loading xml as spread workbook  - ERROR  when adding a row at the end
                //fpSpread1.Open(xmlPathWorkbook);

	        }
	        catch (Exception ex)
	        {
		        MessageBox.Show(ex.Message);
	        }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // ERROR  -  - This works in Spread v5.0.3518, but not in v6.0.3501.2008
            // --------------------------------------------------------------------------
            fpSpread1.Sheets[0].AddRows(fpSpread1.Sheets[0].RowCount - 1, 1);   // IndexOutOfRangeException "Invalid row index specified: 1999 (current value of Rows is 500)"


            // OK - Works in v6.0.3501.2008
            // --------------------------------------------
            //fpSpread1.Sheets[0].AddRows(500, 1);


            // ERROR Does not work in v6.0.3501.2008
            // --------------------------------------------
            //fpSpread1.Sheets[0].AddRows(501, 1);      // IndexOutOfRangeException "Invalid row index specified: 1999 (current value of Rows is 500)"
        }
    }
}
